# SPDX-FileCopyrightText: Citadel and contributors
#
# SPDX-License-Identifier: AGPL-3.0-only

# yaml-language-server: $schema=../../app-standard-v4.yml

citadel_version: 4

metadata:
  category: Payments
  name: BTCPay Server
  version: 2.0.5
  tagline: Accept Bitcoin payments. Free, open-source & self-hosted, Bitcoin
    payment processor.
  description: "BTCPay Server is a free and open-source Bitcoin payment processor
    which allows you to accept bitcoin without fees or intermediaries. "
  developers:
    BTCPay Server Foundation: https://btcpayserver.org
  permissions:
  {% if services is containing("lnd") %}
    - lnd
  {% elif services is containing("core-ln") %}
    - core-ln
  {% else %}
    - - lnd
      - core-ln
  {% endif %}
    - bitcoind
  repo:
    Public: https://github.com/btcpayserver/btcpayserver
  support: https://chat.btcpayserver.org
  gallery:
    - 1.jpg
    - 2.jpg
    - 3.jpg

services:
  main:
    port: 3000
    image: btcpayserver/btcpayserver:2.0.5@sha256:14dc2f6ca638d126f17d53d7bfa89c798b82f241b9307c113a84b29df8481ab6
    depends_on:
      - nbxplorer
      - postgres
    entrypoint:
      - dotnet
      - BTCPayServer.dll
    environment:
      HOME: /data
      BTCPAY_DATADIR: /data
      BTCPAY_PLUGINDIR: /data/plugins
      BTCPAY_DOCKERDEPLOYMENT: "false"
      BTCPAY_POSTGRES: User
        ID=postgres;Host=$APP_BTCPAY_SERVER_POSTGRES_IP;Port=5432;Application
        Name=btcpayserver;Database=btcpayserver$BITCOIN_NETWORK
      BTCPAY_NETWORK: $BITCOIN_NETWORK
      BTCPAY_BIND: 0.0.0.0:3000
      BTCPAY_CHAINS: btc
      BTCPAY_BTCEXPLORERURL: http://$APP_BTCPAY_SERVER_NBXPLORER_IP:32838
      {% if services is containing("lnd") %}
      BTCPAY_BTCLIGHTNING: type=lnd-rest;server=https://$APP_LND_SERVICE_IP:8080/;macaroonfilepath=/lnd/data/chain/bitcoin/$BITCOIN_NETWORK/admin.macaroon;allowinsecure=true
      {% elif services is containing("core-ln") %}
      BTCPAY_BTCLIGHTNING: type=clightning;server=unix://c-lightning/bitcoin/lightning-rpc
      {%endif %}
      BTCPAY_SOCKSENDPOINT: $TOR_PROXY_IP:$TOR_PROXY_PORT
    mounts:
      {% if services is containing("lnd") %}
      lnd: /lnd
      {% elif services is containing("core-ln") %}
      core-ln: /c-lightning
      {%endif %}
      data:
        data/nbxplorer: /data/.nbxplorer
        data/btcpay: /data
    user: 1000:1000
  nbxplorer:
    depends_on:
      - postgres
    image: nicolasdorier/nbxplorer:2.3.62@sha256:8f484e37fc2ab7f9bf7524ad7d4d5a09a39d5bc3dee5f84cfa43f93be3396e92
    user: 1000:1000
    environment:
      NBXPLORER_DATADIR: /data
      NBXPLORER_NETWORK: $BITCOIN_NETWORK
      NBXPLORER_PORT: "32838"
      NBXPLORER_BIND: 0.0.0.0
      NBXPLORER_CHAINS: btc
      NBXPLORER_SIGNALFILEDIR: /data
      NBXPLORER_BTCRPCURL: http://$BITCOIN_IP:$BITCOIN_RPC_PORT
      NBXPLORER_BTCNODEENDPOINT: $BITCOIN_IP:$BITCOIN_P2P_PORT
      NBXPLORER_BTCRPCUSER: $BITCOIN_RPC_USER
      NBXPLORER_BTCRPCPASSWORD: $BITCOIN_RPC_PASS
      NBXPLORER_POSTGRES: User
        ID=postgres;Host=$APP_BTCPAY_SERVER_POSTGRES_IP;Port=5432;Application
        Name=nbxplorer;MaxPoolSize=20;Database=nbxplorer${BITCOIN_NETWORK}
      NBXPLORER_AUTOMIGRATE: "1"
      NBXPLORER_NOMIGRATEEVTS: "1"
    mounts:
      data:
        data/nbxplorer: /data
  postgres:
    image: ghcr.io/runcitadel/postgres:main@sha256:8f25afe966a63fd3f11a1052e73f30b9de5ddc0876bebaaf944d485374c73c01
    user: 1000:1000
    environment:
      POSTGRES_HOST_AUTH_METHOD: trust
    mounts:
      data:
        data/postgres: /var/lib/postgresql/data
